#!/usr/bin/env python

import pygame
import math
import random

use_sound = True
pygame.init()
#pygame.font.init()

#try:
#    pygame.mixer.init()
#except:
#    use_sound = False

class Snail:
    def __init__(self, img, n):
        self.num = n
        self.y = n * 160 + 16
        self.x = 0
        self.dx = random.gauss(0.1, 0.05)
        self.image = img
        self.finished = False
        
    def update(self):
        #self.dx += random.gauss(0.0001, 0.01)
        self.dx = (self.dx * 9 + random.gauss(0.2, 0.9)) / 10.0
        self.x += self.dx
        if (self.x > 640 - self.image.get_width() - 16) and not self.finished:
            finish_line(self.num)
            self.finished = True
        
    def draw(self, surf):
        surf.blit(self.image, (int(self.x), int(self.y)))

screen = pygame.display.set_mode((640, 480))

#font = pygame.font.Font("PhaistosDisk_-_Layne_Lighthouse.ttf", 24)

img = {}
img['track'] = pygame.image.load("track.png")
img['win'] = pygame.image.load("win.png")
img['lose'] = pygame.image.load("lose.png")
img['snail'] = []
img['snail'].append(pygame.image.load("snail_1.png").convert_alpha())
img['snail'].append(pygame.image.load("snail_2.png").convert_alpha())
img['snail'].append(pygame.image.load("snail_3.png").convert_alpha())
img['instructions'] = pygame.image.load("instructions.png").convert_alpha()
img['star'] = pygame.image.load("star.png").convert_alpha()
img['trophy'] = pygame.image.load("trophy.png").convert_alpha()

snd = {}
if use_sound:
    pass

def reset():
    global snails, pick, finished, countdown, winner
    snails = [Snail(img['snail'][i], i) for i in xrange(3)]
    pick = 0
    finished = 0
    countdown = 0
    winner = -1

def finish_line(n):
    global finished, countdown, state, winner
    finished += 1
    
    if finished == 1:
        winner = n
        
    if finished >= 3:
        if pick == winner:
            state = 3
        else:
            state = 4
        countdown = 60 * 3
        

reset()

clock = pygame.time.Clock()
state = 1
while state != 0:
    key = pygame.key.get_pressed()
    if state == 1:
        # TITLE
        screen.blit(img['track'], (0,0))
        for s in snails:
            s.draw(screen)
            
        screen.blit(img['instructions'], (320, 210))
        
    elif state == 2:
        # GAME
        screen.blit(img['track'], (0,0))
        for s in snails:
            s.update()
            s.draw(screen)
            
        screen.blit(img['star'], (snails[pick].x - 10, pick * 160 + 4))
        
        if winner > -1:
            screen.blit(img['trophy'], (506, 160 * winner + 30))
        
    elif state == 3:
        # WIN
        screen.blit(img['win'], (0,0))
        countdown -= 1
        if countdown == 0:
            reset()
            state = 1
    
    elif state == 4:
        #LOSE
        screen.blit(img['lose'], (0,0))
        countdown -= 1
        if countdown == 0:
            reset()
            state = 1
    
    clock.tick(60)
    pygame.display.flip()
    
    for event in pygame.event.get():
        if event.type == pygame.QUIT:
            state = 0
            
        if event.type == pygame.KEYDOWN:
            if event.key == pygame.K_SPACE:
                if state == 1:
                    state = 2
                
                if (state == 3) or (state == 4):
                    reset()
                    state = 1
                    
            if event.key == pygame.K_ESCAPE:
                state = 0
        
        if event.type == pygame.MOUSEBUTTONDOWN:
            if state == 1:
                pick = event.pos[1] / 160
                state = 2

pygame.quit()
